=== modified file 'lib/lp/soyuz/scripts/publishdistro.py'
--- lib/lp/soyuz/scripts/publishdistro.py	2011-07-21 11:49:31 +0000
+++ lib/lp/soyuz/scripts/publishdistro.py	2011-07-21 11:53:47 +0000
@@ -170,25 +170,15 @@
                 "Can only specify one of partner, ppa, private-ppa, "
                 "copy-archive and primary-debug.")
 
-        if self.options.all_derived:
-            if self.options.distribution is not None:
+        if self.options.all_derived and self.options.distribution is not None:
                 raise OptionValueError(
                     "Specify --distribution or --all-derived, but not both.")
-        else:
-            if self.options.distribution is None:
-                raise OptionValueError(
-                    "Must specify either --distribution or --all-derived.")
 
         for_ppa = (self.options.ppa or self.options.private_ppa)
         if for_ppa and self.options.distsroot:
             raise OptionValueError(
                 "We should not define 'distsroot' in PPA mode!", )
 
-    def completeOptions(self):
-        """After validation, fill in default option values where needed."""
-        if not self.options.all_derived and self.options.distribution is None:
-            self.options.distribution = "ubuntu"
-
     def findDistros(self):
         """Find the selected distribution(s)."""
         self.logger.debug("Finding distribution object.")
@@ -310,7 +300,6 @@
     def main(self):
         """See `LaunchpadScript`."""
         self.validateOptions()
-        self.completeOptions()
         self.logOptions()
 
         for distribution in self.findDistros():

=== modified file 'lib/lp/soyuz/scripts/tests/test_publishdistro.py'
--- lib/lp/soyuz/scripts/tests/test_publishdistro.py	2011-07-21 11:49:31 +0000
+++ lib/lp/soyuz/scripts/tests/test_publishdistro.py	2011-07-21 11:53:47 +0000
@@ -539,12 +539,6 @@
         script = self.makeScript(args=['--private-ppa', '--distsroot=/tmp'])
         self.assertRaises(OptionValueError, script.validateOptions)
 
-    def test_validateOptions_requires_distro_by_default(self):
-        # Unless --all-derived is given, validateOptions requires the
-        # --distribution option.
-        self.assertRaises(
-            OptionValueError, PublishDistro(test_args=[]).validateOptions)
-
     def test_validateOptions_accepts_all_derived_without_distro(self):
         # If --all-derived is given, the --distribution option is not
         # required.
@@ -559,28 +553,17 @@
         script = PublishDistro(test_args=['-d', distro.name, '--all-derived'])
         self.assertRaises(OptionValueError, script.validateOptions)
 
-    def test_completeOptions_does_nothing_if_all_derived_specified(self):
-        script = PublishDistro(test_args=['--all-derived'])
-        script.completeOptions()
-        self.assertIs(None, script.options.distribution)
-
-    def test_completeOptions_does_nothing_if_distro_speficied(self):
-        distro_name = self.factory.getUniqueUnicode()
-        script = PublishDistro(test_args=['-d', distro_name])
-        script.completeOptions()
-        self.assertEqual(distro_name, script.options.distribution)
-
-    def test_completeOptions_makes_distribution_default_to_ubuntu(self):
-        script = PublishDistro(test_args=[])
-        script.completeOptions()
-        self.assertEqual("ubuntu", script.options.distribution)
-
     def test_findDistros_finds_selected_distribution(self):
         # findDistros looks up and returns the distribution named on the
         # command line.
         distro = self.makeDistro()
         self.assertEqual([distro], self.makeScript(distro).findDistros())
 
+    def test_findDistro_finds_ubuntu_by_default(self):
+        ubuntu = getUtility(ILaunchpadCelebrities).ubuntu
+        self.assertContentEqual(
+            [ubuntu], PublishDistro(test_args=[]).findDistros())
+
     def test_findDistros_raises_if_selected_distro_not_found(self):
         # If findDistro can't find the distribution, that's an
         # OptionValueError.

